## ulfius 2.7.13

=== CMakeLists.txt ===
#
# Ulfius library
#
# CMake file used to build all programs
#
# Copyright 2018      Silvio Clecio <silvioprog@gmail.com>
# Copyright 2018-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(ulfius C)

set(CMAKE_C_STANDARD 99)
if (NOT MSVC)
    set(CMAKE_C_FLAGS "-Wall -Werror ${CMAKE_C_FLAGS}")
endif()

# library info

set(ULFIUS_LIBS )

set(PROJECT_DESCRIPTION "Web Framework to build REST APIs, Webservices or any HTTP endpoint in C language. Can stream large amount of data, integrate JSON data with Jansson, and create websocket services")
set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/ulfius/")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/ulfius/issues")
set(LIBRARY_VERSION_MAJOR "2")
set(LIBRARY_VERSION_MINOR "7")
set(LIBRARY_VERSION_PATCH "13")

set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
else ()
    set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
endif ()
if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
else ()
    set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
endif ()
if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
    set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
else ()
    set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
endif ()
set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")

set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
set(ORCANIA_VERSION_REQUIRED "2.3.2")
set(YDER_VERSION_REQUIRED "1.4.19")
set(JANSSON_VERSION_REQUIRED "2.1")

# cmake modules

set(U_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
list(APPEND CMAKE_MODULE_PATH "${U_CMAKE_MODULE_PATH}")

include(GNUInstallDirs)
include(CheckSymbolExists)
include(CMakeDependentOption)
include(CMakePackageConfigHelpers)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(UWSC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tools/uwsc)

include_directories(${INC_DIR})

set(LIB_SRC
    ${INC_DIR}/ulfius.h
    ${INC_DIR}/u_private.h
    ${INC_DIR}/yuarel.h
    ${SRC_DIR}/u_map.c
    ${SRC_DIR}/u_request.c
    ${SRC_DIR}/u_response.c
    ${SRC_DIR}/u_send_request.c
    ${SRC_DIR}/u_websocket.c
    ${SRC_DIR}/yuarel.c
    ${SRC_DIR}/ulfius.c)

# pthread libraries
find_package (Threads)
list(APPEND ULFIUS_LIBS ${CMAKE_THREAD_LIBS_INIT})

# GNU TLS support
option(WITH_GNUTLS "GNU TLS support" ON)

if (WITH_GNUTLS)
    find_package(GnuTLS REQUIRED)
    list(APPEND ULFIUS_LIBS GnuTLS::GnuTLS)
endif ()

# websocket support

# current websocket implementation depends on GNU TLS, and is not supported on Windows
cmake_dependent_option(WITH_WEBSOCKET "Websocket support" ON "NOT WIN32;WITH_GNUTLS" OFF)
option(WITH_WEBSOCKET_MESSAGE_LIST "Websocket messages list support" ON)

if (WITH_WEBSOCKET)
    set(MHD_MIN_VERSION 0.9.53)
else ()
    set(MHD_MIN_VERSION 0.9.51)
endif ()

if (WITH_GNUTLS)
    set(U_DISABLE_GNUTLS OFF)
else ()
    set(U_DISABLE_GNUTLS ON)
endif ()

find_package(MHD ${MHD_MIN_VERSION} REQUIRED)
list(APPEND ULFIUS_LIBS MHD::MHD)
include_directories(${MHD_INCLUDE_DIRS})
if (MHD_VERSION_STRING VERSION_LESS "0.9.53")
    set(WITH_WEBSOCKET OFF)
endif ()

if (WITH_WEBSOCKET)
    set(U_DISABLE_WEBSOCKET OFF)
    find_package(ZLIB REQUIRED)
    list(APPEND ULFIUS_LIBS ZLIB::ZLIB)
else ()
    set(U_DISABLE_WEBSOCKET ON)
endif ()

if (WITH_WEBSOCKET_MESSAGE_LIST)
    set(U_DISABLE_WS_MESSAGE_LIST OFF)
else ()
    set(U_DISABLE_WS_MESSAGE_LIST ON)
endif ()

option(WITH_CURL "Use Curl library" ON)

if (WITH_CURL)
    find_package(CURL REQUIRED)
    # FIXME: CMake 3.12.4 creates CURL::libcurl
    if (NOT TARGET CURL::libcurl)
        add_library(CURL::libcurl INTERFACE IMPORTED)
        set_target_properties(CURL::libcurl PROPERTIES
                INTERFACE_LINK_LIBRARIES "${CURL_LIBRARIES}"
                INTERFACE_INCLUDE_DIRECTORIES "${CURL_INCLUDE_DIRS}")
    endif ()
    list(APPEND ULFIUS_LIBS CURL::libcurl)
    set(U_DISABLE_CURL OFF)
else ()
    set(U_DISABLE_CURL ON)
endif ()

option(WITH_JANSSON "Use jansson library" ON)

if (WITH_JANSSON)
    set(JANSSON_MIN_VERSION 2.4)
    find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
    list(APPEND ULFIUS_LIBS Jansson::Jansson)
    set(U_DISABLE_JANSSON OFF)
else ()
    set(U_DISABLE_JANSSON ON)
endif ()

option(BUILD_SHARED "Build shared library." ON)
option(BUILD_STATIC "Build static library." OFF)

if (NOT BUILD_STATIC AND NOT BUILD_SHARED)
    message(FATAL_ERROR "BUILD_SHARED and BUILD_STATIC cannot be both disabled")
endif ()

# TO MY FUTURE SELF
# The following 2 blocks are put BEFORE searching for Orcania and Yder by design
# Otherwise it will lead to cmake errors
# DON'T MOVE IT BELOW PLEASE!

# static library

if (BUILD_STATIC)
    add_library(ulfius_static STATIC ${LIB_SRC})
    add_library(Ulfius::Ulfius-static ALIAS ulfius_static)
    target_include_directories(ulfius_static
        PUBLIC "$<BUILD_INTERFACE:${INC_DIR}>"
        PUBLIC "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
        PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
    target_link_libraries(ulfius_static PUBLIC ${ULFIUS_LIBS})
    target_compile_definitions(ulfius_static PUBLIC O_STATIC_LIBRARY)
    set_target_properties(ulfius_static PROPERTIES
            PUBLIC_HEADER "${INC_DIR}/ulfius.h;${PROJECT_BINARY_DIR}/ulfius-cfg.h"
            OUTPUT_NAME ulfius
            EXPORT_NAME Ulfius-static)
    if (MSVC)
        set_target_properties(ulfius_static PROPERTIES
                OUTPUT_NAME ulfius-static)
    endif ()
    if (NOT MSVC)
        target_compile_options(ulfius_static PRIVATE -Wextra -Wconversion)
    endif ()
    set(ulfius_lib ulfius_static)
endif ()

# shared library

if (BUILD_SHARED)
    add_library(ulfius SHARED ${LIB_SRC})
    add_library(Ulfius::Ulfius ALIAS ulfius)
    target_include_directories(ulfius
        PUBLIC "$<BUILD_INTERFACE:${INC_DIR}>"
        PUBLIC "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
        PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
    target_link_libraries(ulfius PUBLIC ${ULFIUS_LIBS})
    set_target_properties(ulfius PROPERTIES
            PUBLIC_HEADER "${INC_DIR}/ulfius.h;${PROJECT_BINARY_DIR}/ulfius-cfg.h"
            VERSION "${LIBRARY_VERSION}"
            SOVERSION "${LIBRARY_SOVERSION}"
            WINDOWS_EXPORT_ALL_SYMBOLS TRUE
            EXPORT_NAME Ulfius)
    if (WIN32)
        set_target_properties(ulfius PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
    endif ()
    if (NOT MSVC)
        target_compile_options(ulfius PRIVATE -Wextra -Wconversion)
    endif()
    set(ulfius_lib ulfius)
endif ()

# documentation

option(BUILD_ULFIUS_DOCUMENTATION "Build the documentation." OFF)
if (BUILD_ULFIUS_DOCUMENTATION)
    find_package(Doxygen REQUIRED)
    if (DOXYGEN_FOUND)
        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)

        configure_file(${doxyfile_in} ${doxyfile} @ONLY)

        add_custom_target(doc
                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                          COMMENT "Generating documentation with Doxygen"
                          VERBATIM)

    else ()
        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
    endif ()
endif ()

# dependencies

option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)

option(SEARCH_ORCANIA_U "Search for ORCANIA library" ON)
if (SEARCH_ORCANIA_U)
    set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
    find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
    if (NOT Orcania_FOUND)
        if (DOWNLOAD_DEPENDENCIES)
            include(DownloadProject)
            download_project(PROJ orcania # ... otherwise, download archive
                             URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
                             QUIET)
            add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
            # The following lines can be removed once Orcania has full target support
            if (TARGET orcania)
                if (NOT TARGET Orcania::Orcania)
                    add_library(Orcania::Orcania INTERFACE IMPORTED)
                    set_target_properties(Orcania::Orcania PROPERTIES
                            INTERFACE_INCLUDE_DIRECTORIES "${orcania_SOURCE_DIR};${orcania_SOURCE_DIR}/include;${orcania_BINARY_DIR}"
                            INTERFACE_LINK_LIBRARIES orcania)
                endif ()
            endif ()
            if (TARGET orcania_static)
                if (NOT TARGET Orcania::Orcania-static)
                    add_library(Orcania::Orcania-static INTERFACE IMPORTED)
                    set_target_properties(Orcania::Orcania-static PROPERTIES
                        INTERFACE_INCLUDE_DIRECTORIES "${orcania_SOURCE_DIR};${orcania_SOURCE_DIR}/include;${orcania_BINARY_DIR}"
                        INTERFACE_LINK_LIBRARIES orcania-_static)
                endif ()
            endif ()
        else ()
            message( FATAL_ERROR "Orcania not found")
        endif ()
    else()
        if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
            message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
        else ()
            message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
        endif ()
    endif ()
endif ()

if (BUILD_SHARED)
    target_link_libraries(ulfius PUBLIC $<TARGET_NAME:Orcania::Orcania>)
endif ()
if (BUILD_STATIC)
    if(TARGET Orcania::Orcania-static)
        target_link_libraries(ulfius_static PUBLIC $<TARGET_NAME:Orcania::Orcania-static>)
    else()
        target_link_libraries(ulfius_static PUBLIC $<TARGET_NAME:Orcania::Orcania>)
    endif()
endif ()

option(WITH_YDER "Use Yder library to log messages" ON)
option(SEARCH_YDER "Search for Yder library" ON)

if (WITH_YDER)
    set(U_DISABLE_YDER OFF)
    set(SEARCH_ORCANIA OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during yder search and download

    if (SEARCH_YDER)
        set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
        find_package(Yder ${YDER_VERSION_REQUIRED} QUIET) # try to find Yder
        if (NOT Yder_FOUND)
            if (DOWNLOAD_DEPENDENCIES)
                include(DownloadProject)
                download_project(PROJ yder # ... otherwise, download archive
                                  URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
                                  QUIET)
                add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})

=== Makefile ===
#
# Ulfius Framework
#
# Makefile used to build all programs
#
# Copyright 2014-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

LIBULFIUS_LOCATION=./src
EXAMPLES_LOCATION=./example_programs
ifndef UWSCFLAG
UWSC_LOCATION=./tools/uwsc
endif
TESTS_LOCATION=./test

all:
	cd $(LIBULFIUS_LOCATION) && $(MAKE) $*
ifndef UWSCFLAG
	cd $(UWSC_LOCATION) && $(MAKE) $*
endif

debug:
	cd $(LIBULFIUS_LOCATION) && $(MAKE) debug $*
ifndef UWSCFLAG
	cd $(UWSC_LOCATION) && $(MAKE) debug $*
endif

clean:
	cd $(LIBULFIUS_LOCATION) && $(MAKE) clean
	cd $(EXAMPLES_LOCATION) && $(MAKE) clean
ifndef UWSCFLAG
	cd $(UWSC_LOCATION) && $(MAKE) clean
endif
	cd $(TESTS_LOCATION) && $(MAKE) clean
	cd $(TESTS_LOCATION)/autobahn && $(MAKE) clean
	rm -rf doc/html

examples:
	cd $(EXAMPLES_LOCATION) && $(MAKE) $*

install:
	cd $(LIBULFIUS_LOCATION) && $(MAKE) install
ifndef UWSCFLAG
	cd $(UWSC_LOCATION) && $(MAKE) install
endif

uninstall:
	cd $(LIBULFIUS_LOCATION) && $(MAKE) uninstall
ifndef UWSCFLAG
	cd $(UWSC_LOCATION) && $(MAKE) uninstall
endif

check:
	cd $(TESTS_LOCATION) && $(MAKE)

doxygen:
	doxygen doc/doxygen.cfg

=== src/Makefile ===
#
# Ulfius Framework
#
# Makefile used to build the software
#
# Copyright 2015-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
PROJECT_NAME=ulfius
PROJECT_DESCRIPTION=Web Framework to build REST APIs, Webservices or any HTTP endpoint in C language. Can stream large amount of data, integrate JSON data with Jansson, and create websocket services
PROJECT_BUGREPORT_PATH=https://github.com/babelouest/ulfius/issues
PKGCONF_REQ=
PKGCONF_REQ_PRIVATE=
ULFIUS_INCLUDE=../include
CONFIG_TEMPLATE=$(ULFIUS_INCLUDE)/ulfius-cfg.h.in
CONFIG_FILE=$(ULFIUS_INCLUDE)/ulfius-cfg.h
PKGCONFIG_FILE=../libulfius.pc
PKGCONFIG_TEMPLATE=../libulfius.pc.in
DESTDIR=/usr/local
CC=gcc
CFLAGS+=-c -pedantic -std=gnu99 -fPIC -Wall -Werror -Wextra -Wconversion -D_REENTRANT -I$(ULFIUS_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBSDEP=-lmicrohttpd -lpthread -lz
LIBS=-L$(DESTDIR)/lib -lc $(LDFLAGS)
LIB_STATIC=
LIB_YDER=
SONAME = -soname
ifeq ($(shell uname -s),Darwin)
	SONAME = -install_name
endif
OBJECTS=ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o yuarel.o
OUTPUT=libulfius.so
VERSION_MAJOR=2
VERSION_MINOR=7
VERSION_PATCH=13

ifndef JANSSONFLAG
DISABLE_JANSSON=0
LJANSSON=-ljansson
else
DISABLE_JANSSON=1
endif

ifndef CURLFLAG
DISABLE_CURL=0
LCURL=-lcurl
else
DISABLE_CURL=1
endif

ifndef GNUTLSFLAG
DISABLE_GNUTLS=0
LGNUTLS=-lgnutls
else
DISABLE_GNUTLS=1
WEBSOCKETFLAG=1
endif

ifndef WEBSOCKETFLAG
DISABLE_WEBSOCKET=0
DISABLE_WEBSOCKET_MESSAGE=0
else
DISABLE_WEBSOCKET=1
endif

ifndef WEBSOCKETMESSAGEFLAG
DISABLE_WEBSOCKET_MESSAGE=0
else
DISABLE_WEBSOCKET_MESSAGE=1
endif

ifndef YDERFLAG
DISABLE_YDER=0
LYDER=-lyder
LIB_YDER=$(LYDER)
else
DISABLE_YDER=1
endif

ifndef FREERTOSFLAG
WITH_FREERTOS=0
else
WITH_FREERTOS=1
endif

ifndef LWIPFLAG
WITH_LWIP=0
else
CFLAGS+= $(shell pkg-config --cflags lwip)
LIBS+= $(shell pkg-config --libs lwip)
WITH_LWIP=1
endif

ifeq ($(WITH_FREERTOS)$(WITH_LWIP),11)
$(error FREERTOSFLAG and LWIPFLAG can't be enabled together)
endif

.PHONY: all clean

all: release

$(CONFIG_FILE):
	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
	@echo Config file $(CONFIG_FILE) generated
	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(CONFIG_FILE)
	@sed -i -e 's/$${PROJECT_VERSION_MAJOR}/$(VERSION_MAJOR)/g' $(CONFIG_FILE)
	@sed -i -e 's/$${PROJECT_VERSION_MINOR}/$(VERSION_MINOR)/g' $(CONFIG_FILE)
	@sed -i -e 's/$${PROJECT_VERSION_PATCH}/$(VERSION_PATCH)/g' $(CONFIG_FILE)
	@sed -i -e 's/$${PROJECT_VERSION_NUMBER}/$(shell printf '%02d' $(VERSION_MAJOR))$(shell printf '%02d' $(VERSION_MINOR))$(shell printf '%02d' $(VERSION_PATCH))/g' $(CONFIG_FILE)
	@if [ "$(DISABLE_JANSSON)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine U_DISABLE_JANSSON/\#define U_DISABLE_JANSSON/g' $(CONFIG_FILE); \
		echo "JANSSON SUPPORT    DISABLED"; \
	else \
		sed -i -e 's/\#cmakedefine U_DISABLE_JANSSON/\/* #undef U_DISABLE_JANSSON *\//g' $(CONFIG_FILE); \
		echo "JANSSON SUPPORT    ENABLED"; \
	fi
	@if [ "$(DISABLE_CURL)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine U_DISABLE_CURL/\#define U_DISABLE_CURL/g' $(CONFIG_FILE); \
		echo "CURL SUPPORT       DISABLED"; \
	else \
		sed -i -e 's/\#cmakedefine U_DISABLE_CURL/\/* #undef U_DISABLE_CURL *\//g' $(CONFIG_FILE); \
		echo "CURL SUPPORT       ENABLED"; \
	fi
	@if [ "$(DISABLE_GNUTLS)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine U_DISABLE_GNUTLS/\#define U_DISABLE_GNUTLS/g' $(CONFIG_FILE); \
		echo "GNUTLS SUPPORT     DISABLED"; \
	else \
		sed -i -e 's/\#cmakedefine U_DISABLE_GNUTLS/\/* #undef U_DISABLE_GNUTLS *\//g' $(CONFIG_FILE); \
		echo "GNUTLS SUPPORT     ENABLED"; \
	fi
	@pkg-config --atleast-version=0.9.53 libmicrohttpd; \
	if [ $$? -ne 0 ] || [ "$(DISABLE_WEBSOCKET)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine U_DISABLE_WEBSOCKET/\#define U_DISABLE_WEBSOCKET/g' $(CONFIG_FILE); \
		echo "WEBSOCKET SUPPORT  DISABLED"; \
	else \
		sed -i -e 's/\#cmakedefine U_DISABLE_WEBSOCKET/\/* #undef U_DISABLE_WEBSOCKET *\//g' $(CONFIG_FILE); \
		echo "WEBSOCKET SUPPORT  ENABLED"; \
	fi
	@if [ $$? -ne 0 ] || [ "$(DISABLE_WEBSOCKET_MESSAGE)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine U_DISABLE_WS_MESSAGE_LIST/\#define U_DISABLE_WS_MESSAGE_LIST/g' $(CONFIG_FILE); \
		echo "WS MESSAGE LIST    DISABLED"; \
	else \
		sed -i -e 's/\#cmakedefine U_DISABLE_WS_MESSAGE_LIST/\/* #undef U_DISABLE_WS_MESSAGE_LIST *\//g' $(CONFIG_FILE); \
		echo "WS MESSAGE LIST    ENABLED"; \
	fi
	@if [ "$(DISABLE_YDER)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine U_DISABLE_YDER/\#define U_DISABLE_YDER/g' $(CONFIG_FILE); \
		echo "YDER SUPPORT       DISABLED"; \
	else \
		sed -i -e 's/\#cmakedefine U_DISABLE_YDER/\/* #undef U_DISABLE_YDER *\//g' $(CONFIG_FILE); \
		echo "YDER SUPPORT       ENABLED"; \
	fi
	@if [ "$(WITH_FREERTOS)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine U_WITH_FREERTOS/\#define U_WITH_FREERTOS/g' $(CONFIG_FILE); \
		echo "FREERTOS SUPPORT   ENABLED"; \
	else \
		sed -i -e 's/\#cmakedefine U_WITH_FREERTOS/\/* #undef U_WITH_FREERTOS *\//g' $(CONFIG_FILE); \
		echo "FREERTOS SUPPORT   DISABLED"; \
	fi
	@if [ "$(WITH_LWIP)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine U_WITH_LWIP/\#define U_WITH_LWIP/g' $(CONFIG_FILE); \
		echo "LWIP SUPPORT       ENABLED"; \
	else \
		sed -i -e 's/\#cmakedefine U_WITH_LWIP/\/* #undef U_WITH_LWIP *\//g' $(CONFIG_FILE); \
		echo "LWIP SUPPORT       DISABLED"; \
	fi

$(PKGCONFIG_FILE):
	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
	@sed -i -e 's#@PKGCONFIG_TARGET_LIBDIR@#$${prefix}/lib#g' $(PKGCONFIG_FILE)
	@sed -i -e 's#@PKGCONFIG_TARGET_INCLUDES@#$${prefix}/include#g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@LIB_STATIC@/$(LIB_STATIC)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@LIB_YDER@/$(LIB_YDER)/g' $(PKGCONFIG_FILE)

target: $(OBJECTS)

%.o: %.c $(CONFIG_FILE) $(ULFIUS_INCLUDE)/ulfius.h $(ULFIUS_INCLUDE)/u_private.h $(ULFIUS_INCLUDE)/yuarel.h
	$(CC) $(CFLAGS) $<

libulfius.so: $(OBJECTS) $(PKGCONFIG_FILE)
	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OBJECTS) $(LIBS) $(LIBSDEP) $(LYDER) $(LJANSSON) $(LCURL) $(LGNUTLS)
	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)

libulfius.a: $(OBJECTS) $(PKGCONFIG_FILE)
	ar rcs libulfius.a $(OBJECTS)

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(CONFIG_FILE) $(PKGCONFIG_FILE)

install: all $(PKGCONFIG_FILE)
	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
	mkdir -p $(DESTDIR)/lib/pkgconfig/ $(DESTDIR)/include
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
	install -m644 $(ULFIUS_INCLUDE)/ulfius.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
	-ldconfig $(DESTDIR)/lib

static-install: static
	install libulfius.a $(DESTDIR)/lib
	mkdir -p $(DESTDIR)/lib/pkgconfig/ $(DESTDIR)/include
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig
	install -m644 $(ULFIUS_INCLUDE)/ulfius.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libulfius.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/ulfius.h
	rm -f $(DESTDIR)/include/$(CONFIG_FILE)
	rm -f $(DESTDIR)/lib/pkgconfig/$(PKGCONFIG_FILE)

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libulfius.so

release: ADDITIONALFLAGS=-O3

release: libulfius.so

static: ADDITIONALFLAGS=-O3

static: LIB_STATIC=$(LIBSDEP) $(LYDER) $(LJANSSON) $(LCURL) $(LGNUTLS)

static: libulfius.a

static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0

static-debug: libulfius.a

=== debian/changelog ===
ulfius (2.7.13-1) unstable; urgency=medium

  * New upstream release
  * d/patches/doc.patch: Update doxygen patch

 -- Nicolas Mora <babelouest@debian.org>  Wed, 08 Feb 2023 12:04:54 -0500

ulfius (2.7.12-1) unstable; urgency=medium

  * d/control: Update Standards-Version to 4.6.2
  * d/libulfius-dev.install: Add cmake dependencies
  * d/copyright: Update copyright year to 2023 for debian/* files

 -- Nicolas Mora <babelouest@debian.org>  Mon, 09 Jan 2023 07:46:52 -0500

ulfius (2.7.11-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update Standards-Version to 4.6.1
  * d/symbols: update symbols
  * d/tests: add unit test

 -- Nicolas Mora <babelouest@debian.org>  Sat, 15 Oct 2022 17:20:19 -0400

=== debian/control ===
Source: ulfius
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
          , Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
             , libmicrohttpd-dev
             , libcurl4-gnutls-dev
             , libgnutls28-dev
             , libjansson-dev
             , liborcania-dev
             , libyder-dev
             , cmake
             , pkg-config
             , check
             , gnutls-bin
             , doxygen
             , zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://github.com/babelouest/ulfius
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/ulfius.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/ulfius.git
Rules-Requires-Root: no

Package: libulfius2.7
Replaces: libulfius2.6, libulfius2.5
Breaks: libulfius2.6, libulfius2.5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Web Framework for REST Applications in C
 Based on GNU Libmicrohttpd for the backend web server, Jansson for the
 json manipulation library, and Libcurl for the http/smtp client API.
 .
 Used to facilitate creation of web applications in C programs with a
 small memory footprint, as in embedded systems applications.
 .
 One can create webservices in HTTP or HTTPS mode, stream data, or
 implement server websockets.

Package: libulfius-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libulfius2.7 (= ${binary:Version})
       , ${misc:Depends}
       , libmicrohttpd-dev
       , libcurl4-gnutls-dev
       , libgnutls28-dev
       , libjansson-dev
       , liborcania-dev
       , libyder-dev
       , libjs-jquery
       , zlib1g-dev
Description: Web Framework for REST Applications in C - development
 Based on GNU Libmicrohttpd for the backend web server, Jansson for the
 json manipulation library, and Libcurl for the http/smtp client API.
 .
 Used to facilitate creation of web applications in C programs with a
 small memory footprint, as in embedded systems applications.
 .
 One can create webservices in HTTP or HTTPS mode, stream data, or
 implement server websockets.
 .
 This package contains the development files.

Package: uwsc
Architecture: any
Depends: ${shlibs:Depends},
       , libulfius2.7 (= ${binary:Version})
       , ${misc:Depends}
Description: Ulfius WebSocket Client
 Simple command-line application to connect to websocket services
 .
 Can connect to websocket services, both ws:// (http) or wss:// (https).
 When the websocket is connected, messages from the server are displayed
 in the terminal and messages can be sent to the service via a prompt >.

## ulfius 2.7.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/ulfius/issues")
 set(LIBRARY_VERSION_MAJOR "2")
 set(LIBRARY_VERSION_MINOR "7")
-set(LIBRARY_VERSION_PATCH "13")
+set(LIBRARY_VERSION_PATCH "14")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -58,8 +58,8 @@
 
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
-set(ORCANIA_VERSION_REQUIRED "2.3.2")
-set(YDER_VERSION_REQUIRED "1.4.19")
+set(ORCANIA_VERSION_REQUIRED "2.3.3")
+set(YDER_VERSION_REQUIRED "1.4.20")
 set(JANSSON_VERSION_REQUIRED "2.1")
 
 # cmake modules
@@ -272,46 +272,11 @@
 
 # dependencies
 
-option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)
-
-option(SEARCH_ORCANIA_U "Search for ORCANIA library" ON)
-if (SEARCH_ORCANIA_U)
-    set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
-    find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
-    if (NOT Orcania_FOUND)
-        if (DOWNLOAD_DEPENDENCIES)
-            include(DownloadProject)
-            download_project(PROJ orcania # ... otherwise, download archive
-                             URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
-                             QUIET)
-            add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
-            # The following lines can be removed once Orcania has full target support
-            if (TARGET orcania)
-                if (NOT TARGET Orcania::Orcania)
-                    add_library(Orcania::Orcania INTERFACE IMPORTED)
-                    set_target_properties(Orcania::Orcania PROPERTIES
-                            INTERFACE_INCLUDE_DIRECTORIES "${orcania_SOURCE_DIR};${orcania_SOURCE_DIR}/include;${orcania_BINARY_DIR}"
-                            INTERFACE_LINK_LIBRARIES orcania)
-                endif ()
-            endif ()
-            if (TARGET orcania_static)
-                if (NOT TARGET Orcania::Orcania-static)
-                    add_library(Orcania::Orcania-static INTERFACE IMPORTED)
-                    set_target_properties(Orcania::Orcania-static PROPERTIES
-                        INTERFACE_INCLUDE_DIRECTORIES "${orcania_SOURCE_DIR};${orcania_SOURCE_DIR}/include;${orcania_BINARY_DIR}"
-                        INTERFACE_LINK_LIBRARIES orcania-_static)
-                endif ()
-            endif ()
-        else ()
-            message( FATAL_ERROR "Orcania not found")
-        endif ()
-    else()
-        if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
-            message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
-        else ()
-            message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
-        endif ()
-    endif ()
+find_package(Orcania ${ORCANIA_VERSION_REQUIRED} REQUIRED)
+if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
+    message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
+else ()
+    message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
 endif ()
 
 if (BUILD_SHARED)
@@ -325,20 +290,76 @@
     endif()
 endif ()
 
-option(WITH_YDER "Use Yder library to log messages" ON)
-option(SEARCH_YDER "Search for Yder library" ON)
-
-if (WITH_YDER)
-    set(U_DISABLE_YDER OFF)
-    set(SEARCH_ORCANIA OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during yder search and download
-
-    if (SEARCH_YDER)
-        set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
-        find_package(Yder ${YDER_VERSION_REQUIRED} QUIET) # try to find Yder
-        if (NOT Yder_FOUND)
-            if (DOWNLOAD_DEPENDENCIES)
-                include(DownloadProject)
-                download_project(PROJ yder # ... otherwise, download archive
-                                  URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
-                                  QUIET)
-                add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
+find_package(Yder ${YDER_VERSION_REQUIRED} REQUIRED)
+if ("${YDER_VERSION_STRING}" VERSION_GREATER_EQUAL "${YDER_VERSION_REQUIRED}")
+    message(STATUS "Yder found: ${YDER_VERSION_STRING}")
+else ()
+    message( FATAL_ERROR "Yder version required: ${YDER_VERSION_REQUIRED} - version installed: ${YDER_VERSION_STRING}")
+endif ()
+
+if (BUILD_SHARED)
+    target_link_libraries(ulfius PUBLIC $<TARGET_NAME:Yder::Yder>)
+endif ()
+if (BUILD_STATIC)
+    if(TARGET Yder::Yder-static)
+        target_link_libraries(ulfius_static PUBLIC $<TARGET_NAME:Yder::Yder-static>)
+    else()
+        target_link_libraries(ulfius_static PUBLIC $<TARGET_NAME:Yder::Yder>)
+    endif()
+endif ()
+
+# build uwsc
+
+cmake_dependent_option(BUILD_UWSC "Build uwsc application." ON "WITH_WEBSOCKET" OFF)
+
+if (BUILD_UWSC)
+    add_executable(uwsc ${UWSC_DIR}/uwsc.c ${INC_DIR}/ulfius.h ${INC_DIR}/u_private.h ${PROJECT_BINARY_DIR}/ulfius-cfg.h)
+    set_target_properties(uwsc PROPERTIES SKIP_BUILD_RPATH TRUE)
+    add_dependencies(uwsc ulfius)
+    target_link_libraries(uwsc PRIVATE "${ulfius_lib}")
+    target_compile_options(uwsc PRIVATE -Wextra -Wconversion)
+    install(TARGETS uwsc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+    INSTALL(FILES ${UWSC_DIR}/uwsc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
+endif ()
+
+set(PKGCONF_REQ "")
+set(PKGCONF_REQ_PRIVATE "liborcania, libyder")
+if (WITH_CURL)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, libcurl")
+endif ()
+if (WITH_JANSSON)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, jansson")
+endif ()
+if (WITH_GNUTLS)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, gnutls >= 3.5.0")
+endif ()
+if (WITH_WEBSOCKET)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, libmicrohttpd >= 0.9.53")
+else ()
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, libmicrohttpd >= 0.9.51")
+endif ()
+
+# build ulfius-cfg.h file
+configure_file(${INC_DIR}/ulfius-cfg.h.in ${PROJECT_BINARY_DIR}/ulfius-cfg.h)
+set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
+
+# tests
+
+option(BUILD_ULFIUS_TESTING "Build the testing tree." OFF) # because we do not use include(CTest)
+
+if (BUILD_ULFIUS_TESTING)
+    find_package(Check REQUIRED)
+    if (CHECK_FOUND)
+        if (NOT WIN32 AND NOT APPLE)
+            include(FindSubunit)
+            find_package(Subunit REQUIRED)
+        endif ()
+
+        enable_testing()
+
+        set(CMAKE_CTEST_COMMAND ctest -V)
+
+        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
+        set(EXAMPLE_CALLBACK_COMPRESSION_DIR ${CMAKE_CURRENT_SOURCE_DIR}/example_callbacks/http_compression/)
+        set(EXAMPLE_CALLBACK_STATIC_FILE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/example_callbacks/static_compressed_inmemory_website/)
+        set(TEST_LIBS Ulfius::Ulfius Check::Check)

=== src/Makefile ===
--- 
+++ 
@@ -43,7 +43,7 @@
 OUTPUT=libulfius.so
 VERSION_MAJOR=2
 VERSION_MINOR=7
-VERSION_PATCH=13
+VERSION_PATCH=14
 
 ifndef JANSSONFLAG
 DISABLE_JANSSON=0

=== debian/changelog ===
ulfius (2.7.14-1A~5.2.0.202412031725) ucs5-2-0-0; urgency=low

  * UCS auto build. The following patches have been applied to the original source package
    00_version_bump.patch

 -- Univention builddaemon <buildd@univention.de>  Tue, 03 Dec 2024 17:25:51 -0000

ulfius (2.7.14-1) unstable; urgency=medium

  * New upstream release
  * d/patches/doc.patch: Update doxygen patch (Closes: #1045534)
  * d/rules: remove doc/html and generated key files in test/cert during dh_clean
  * d/copyright: Remove superfluous files
  * d/rules: Remove configure option -DDOWNLOAD_DEPENDENCIES=OFF

 -- Nicolas Mora <babelouest@debian.org>  Thu, 21 Sep 2023 19:54:22 -0400
